var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';

var Expandable = function (_Component) {
  _inherits(Expandable, _Component);

  _createClass(Expandable, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          _props$className = _props.className,
          className = _props$className === undefined ? '' : _props$className,
          durationMs = _props.durationMs,
          props = _objectWithoutProperties(_props, ['className', 'durationMs']);

      var isOpen = this.state.isOpen;


      return React.createElement('div', _extends({
        ref: this.getRef,
        className: 'mt-expandable ' + (isOpen ? 'mt-expandable-open' : '') + ' ' + className
      }, props));
    }
  }, {
    key: 'getSnapshotBeforeUpdate',
    value: function getSnapshotBeforeUpdate() {
      return this.el ? this.el.getBoundingClientRect() : null;
    }
  }]);

  function Expandable(props) {
    _classCallCheck(this, Expandable);

    var _this = _possibleConstructorReturn(this, (Expandable.__proto__ || Object.getPrototypeOf(Expandable)).call(this, props));

    _this.getRef = function (el) {
      _this.el = el;
    };

    _this.state = {
      isOpen: props.open,
      isOpenQueue: null,
      isAnimating: false
    };
    return _this;
  }

  _createClass(Expandable, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var _this2 = this;

      if (snapshot && this.el) {
        if (prevState.isOpen !== this.state.isOpen) {
          var _props$durationMs = this.props.durationMs,
              durationMs = _props$durationMs === undefined ? 200 : _props$durationMs;


          var bb = this.el.getBoundingClientRect();
          this.el.style.height = snapshot.height + 'px';

          requestAnimationFrame(function () {
            requestAnimationFrame(function () {
              _this2.el.style.transition = 'all ' + durationMs + 'ms ease-out';
              _this2.el.style.height = bb.height + 'px';

              setTimeout(function () {
                _this2.el.style = '';

                _this2.setState({
                  isAnimating: false
                });
              }, durationMs);
            });
          });
        }
      }
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(nextProps, prevState) {
      // When the open prop differs from our previous state, then we either need to
      // start animating, or we need to queue the open
      if (nextProps.open !== prevState.isOpen) {
        if (prevState.isAnimating) {
          return {
            isOpenQueue: nextProps.open
          };
        } else {
          return {
            isAnimating: true,
            isOpen: nextProps.open
          };
        }
      }

      return null;
    }
  }]);

  return Expandable;
}(Component);

export default Expandable;