var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import Expandable from '../expandable/expandable';
import IconKeyboardArrowDown from '../icons/icon-keyboard-arrow-down';

var ExpansionPanel = function (_Component) {
  _inherits(ExpansionPanel, _Component);

  function ExpansionPanel() {
    _classCallCheck(this, ExpansionPanel);

    return _possibleConstructorReturn(this, (ExpansionPanel.__proto__ || Object.getPrototypeOf(ExpansionPanel)).apply(this, arguments));
  }

  _createClass(ExpansionPanel, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          _props$className = _props.className,
          className = _props$className === undefined ? '' : _props$className,
          children = _props.children,
          _props$open = _props.open,
          open = _props$open === undefined ? false : _props$open,
          props = _objectWithoutProperties(_props, ['className', 'children', 'open']);

      return React.createElement(
        'div',
        _extends({
          className: 'mt-expansionPanel ' + (open ? 'mt-expansionPanel-open' : '') + ' ' + className
        }, props),
        React.Children.map(children, function (child) {
          return React.cloneElement(child, { open: open });
        })
      );
    }
  }]);

  return ExpansionPanel;
}(Component);

ExpansionPanel.Header = function (_ref) {
  var _ref$className = _ref.className,
      className = _ref$className === undefined ? '' : _ref$className,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['className', 'children']);

  return React.createElement(
    'div',
    _extends({ className: 'mt-expansionPanel_header ' + className }, props),
    children,
    React.createElement(IconKeyboardArrowDown, {
      className: 'mt-expansionPanel_icon',
      size: '1.5em'
    })
  );
};

ExpansionPanel.Body = function (_ref2) {
  var _ref2$className = _ref2.className,
      className = _ref2$className === undefined ? '' : _ref2$className,
      children = _ref2.children,
      _ref2$open = _ref2.open,
      open = _ref2$open === undefined ? false : _ref2$open,
      props = _objectWithoutProperties(_ref2, ['className', 'children', 'open']);

  return React.createElement(
    Expandable,
    _extends({
      open: open,
      className: 'mt-expansionPanel_body ' + className
    }, props),
    React.createElement(
      'div',
      { className: 'mt-expansionPanel_bodyWrapper' },
      children
    )
  );
};

export default ExpansionPanel;