var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import InputComponent from '../input/input';
import TextAreaComponent from '../text-area/text-area';

var Field = function (_Component) {
  _inherits(Field, _Component);

  function Field() {
    _classCallCheck(this, Field);

    return _possibleConstructorReturn(this, (Field.__proto__ || Object.getPrototypeOf(Field)).apply(this, arguments));
  }

  _createClass(Field, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          _props$className = _props.className,
          className = _props$className === undefined ? '' : _props$className,
          _props$required = _props.required,
          required = _props$required === undefined ? false : _props$required,
          props = _objectWithoutProperties(_props, ['className', 'required']);

      return React.createElement('label', _extends({
        className: 'mt-field ' + (required ? 'mt-field-required' : '') + ' ' + className
      }, props));
    }
  }]);

  return Field;
}(Component);

Field.Input = InputComponent;
Field.TextArea = TextAreaComponent;

Field.Label = function (_ref) {
  var _ref$className = _ref.className,
      className = _ref$className === undefined ? '' : _ref$className,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['className', 'children']);

  return React.createElement(
    'div',
    _extends({ className: 'mt-field_label ' + className }, props),
    React.createElement(
      'span',
      null,
      children
    )
  );
};

Field.ErrorMessage = function (_ref2) {
  var _ref2$className = _ref2.className,
      className = _ref2$className === undefined ? '' : _ref2$className,
      props = _objectWithoutProperties(_ref2, ['className']);

  return React.createElement('div', _extends({ className: 'mt-field_errorMessage ' + className }, props));
};

export default Field;


Field.Label.propTypes = {
  className: PropTypes.string
};

Field.ErrorMessage.propTypes = {
  className: PropTypes.string
};

Field.propTypes = {
  className: PropTypes.string,
  required: PropTypes.bool
};