'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

let Expandable = function (_Component) {
  _inherits(Expandable, _Component);

  Expandable.prototype.render = function render() {
    var _props = this.props,
        _props$className = _props.className;

    const className = _props$className === undefined ? '' : _props$className,
          durationMs = _props.durationMs,
          props = _objectWithoutProperties(_props, ['className', 'durationMs']);

    const isOpen = this.state.isOpen;


    return _react2.default.createElement('div', _extends({
      ref: this.getRef,
      className: `mt-expandable ${isOpen ? 'mt-expandable-open' : ''} ${className}`
    }, props));
  };

  Expandable.prototype.getSnapshotBeforeUpdate = function getSnapshotBeforeUpdate() {
    return this.el ? this.el.getBoundingClientRect() : null;
  };

  function Expandable(props) {
    _classCallCheck(this, Expandable);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.getRef = el => {
      _this.el = el;
    };

    _this.state = {
      isOpen: props.open,
      isOpenQueue: null,
      isAnimating: false
    };
    return _this;
  }

  Expandable.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
    // When the open prop differs from our previous state, then we either need to
    // start animating, or we need to queue the open
    if (nextProps.open !== prevState.isOpen) {
      if (prevState.isAnimating) {
        return {
          isOpenQueue: nextProps.open
        };
      } else {
        return {
          isAnimating: true,
          isOpen: nextProps.open
        };
      }
    }

    return null;
  };

  Expandable.prototype.componentDidUpdate = function componentDidUpdate(prevProps, prevState, snapshot) {
    if (snapshot && this.el) {
      if (prevState.isOpen !== this.state.isOpen) {
        var _props$durationMs = this.props.durationMs;
        const durationMs = _props$durationMs === undefined ? 200 : _props$durationMs;


        const bb = this.el.getBoundingClientRect();
        this.el.style.height = `${snapshot.height}px`;

        requestAnimationFrame(() => {
          requestAnimationFrame(() => {
            this.el.style.transition = `all ${durationMs}ms ease-out`;
            this.el.style.height = `${bb.height}px`;

            setTimeout(() => {
              this.el.style = '';

              this.setState({
                isAnimating: false
              });
            }, durationMs);
          });
        });
      }
    }
  };

  return Expandable;
}(_react.Component);

exports.default = Expandable;