'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _expandable = require('../expandable/expandable');

var _expandable2 = _interopRequireDefault(_expandable);

var _iconKeyboardArrowDown = require('../icons/icon-keyboard-arrow-down');

var _iconKeyboardArrowDown2 = _interopRequireDefault(_iconKeyboardArrowDown);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

let ExpansionPanel = function (_Component) {
  _inherits(ExpansionPanel, _Component);

  function ExpansionPanel() {
    _classCallCheck(this, ExpansionPanel);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  ExpansionPanel.prototype.render = function render() {
    var _props = this.props,
        _props$className = _props.className;
    const className = _props$className === undefined ? '' : _props$className,
          children = _props.children;
    var _props$open = _props.open;

    const open = _props$open === undefined ? false : _props$open,
          props = _objectWithoutProperties(_props, ['className', 'children', 'open']);

    return _react2.default.createElement(
      'div',
      _extends({
        className: `mt-expansionPanel ${open ? 'mt-expansionPanel-open' : ''} ${className}`
      }, props),
      _react2.default.Children.map(children, child => _react2.default.cloneElement(child, { open }))
    );
  };

  return ExpansionPanel;
}(_react.Component);

ExpansionPanel.Header = (_ref) => {
  var _ref$className = _ref.className;

  let className = _ref$className === undefined ? '' : _ref$className,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['className', 'children']);

  return _react2.default.createElement(
    'div',
    _extends({ className: `mt-expansionPanel_header ${className}` }, props),
    children,
    _react2.default.createElement(_iconKeyboardArrowDown2.default, {
      className: 'mt-expansionPanel_icon',
      size: '1.5em'
    })
  );
};

ExpansionPanel.Body = (_ref2) => {
  var _ref2$className = _ref2.className;
  let className = _ref2$className === undefined ? '' : _ref2$className,
      children = _ref2.children;
  var _ref2$open = _ref2.open;

  let open = _ref2$open === undefined ? false : _ref2$open,
      props = _objectWithoutProperties(_ref2, ['className', 'children', 'open']);

  return _react2.default.createElement(
    _expandable2.default,
    _extends({
      open: open,
      className: `mt-expansionPanel_body ${className}`
    }, props),
    _react2.default.createElement(
      'div',
      { className: 'mt-expansionPanel_bodyWrapper' },
      children
    )
  );
};

exports.default = ExpansionPanel;