'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _input = require('../input/input');

var _input2 = _interopRequireDefault(_input);

var _textArea = require('../text-area/text-area');

var _textArea2 = _interopRequireDefault(_textArea);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

let Field = function (_Component) {
  _inherits(Field, _Component);

  function Field() {
    _classCallCheck(this, Field);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Field.prototype.render = function render() {
    var _props = this.props,
        _props$className = _props.className;
    const className = _props$className === undefined ? '' : _props$className;
    var _props$required = _props.required;

    const required = _props$required === undefined ? false : _props$required,
          props = _objectWithoutProperties(_props, ['className', 'required']);

    return _react2.default.createElement('label', _extends({
      className: `mt-field ${required ? 'mt-field-required' : ''} ${className}`
    }, props));
  };

  return Field;
}(_react.Component);

Field.Input = _input2.default;
Field.TextArea = _textArea2.default;

Field.Label = (_ref) => {
  var _ref$className = _ref.className;

  let className = _ref$className === undefined ? '' : _ref$className,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['className', 'children']);

  return _react2.default.createElement(
    'div',
    _extends({ className: `mt-field_label ${className}` }, props),
    _react2.default.createElement(
      'span',
      null,
      children
    )
  );
};

Field.ErrorMessage = (_ref2) => {
  var _ref2$className = _ref2.className;

  let className = _ref2$className === undefined ? '' : _ref2$className,
      props = _objectWithoutProperties(_ref2, ['className']);

  return _react2.default.createElement('div', _extends({ className: `mt-field_errorMessage ${className}` }, props));
};

exports.default = Field;


Field.Label.propTypes = {
  className: _propTypes2.default.string
};

Field.ErrorMessage.propTypes = {
  className: _propTypes2.default.string
};

Field.propTypes = {
  className: _propTypes2.default.string,
  required: _propTypes2.default.bool
};