'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ripple = require('../ripple/ripple');

var _ripple2 = _interopRequireDefault(_ripple);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

let IconButton = function (_Component) {
  _inherits(IconButton, _Component);

  function IconButton(...args) {
    var _temp, _this, _ret;

    _classCallCheck(this, IconButton);

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call(this, ...args)), _this), _this.getRippleRef = component => {
      _this.rippleComponent = component;
    }, _this.onClick = e => {
      const onClick = _this.props.onClick;


      if (_this.rippleComponent) {
        _this.rippleComponent.onClick(e);
      }

      if (onClick) {
        onClick(e);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  IconButton.prototype.render = function render() {
    var _props = this.props,
        _props$className = _props.className;
    const className = _props$className === undefined ? '' : _props$className;
    var _props$ripple = _props.ripple;

    const ripple = _props$ripple === undefined ? true : _props$ripple,
          children = _props.children,
          props = _objectWithoutProperties(_props, ['className', 'ripple', 'children']);

    return _react2.default.createElement(
      'button',
      _extends({
        className: `mt-iconButton ${className}`
      }, props, {
        onClick: this.onClick }),
      children,
      ripple && _react2.default.createElement(_ripple2.default, { ref: this.getRippleRef })
    );
  };

  return IconButton;
}(_react.Component);

exports.default = IconButton;


IconButton.propTypes = {
  ripple: _propTypes2.default.bool,
  className: _propTypes2.default.string
};